package dev.peerat.backend.routes.admins;

import java.util.regex.Matcher;

import dev.peerat.framework.Context;
import dev.peerat.framework.HttpReader;
import dev.peerat.framework.HttpWriter;
import dev.peerat.framework.Locker;
import dev.peerat.framework.Locker.Key;
import dev.peerat.framework.Response;
import dev.peerat.framework.Route;
import dev.peerat.framework.utils.json.JsonArray;
import dev.peerat.framework.utils.json.JsonMap;

public class ExceptionLogs implements Response{
	
	private Locker<Exception> locker;
	
	public ExceptionLogs(Locker<Exception> locker){
		this.locker = locker;
	}
	
	@Route(path = "^/admin/exceptions$", needLogin = true, websocket = true)
	public void exec(Matcher matcher, Context context, HttpReader reader, HttpWriter writer) throws Exception{
		Key key = new Key();
		
		locker.init(key);
		try {
			while(!reader.isClosed()){
				locker.lock(key);
				Exception exception = locker.getValue(key);
				JsonMap json = new JsonMap();
				json.set("type", exception.getClass().getSimpleName());
				json.set("message", exception.getMessage());
				JsonArray trace = new JsonArray();
				for(StackTraceElement element : exception.getStackTrace()) trace.add(element.toString());
				json.set("trace", trace);
				
				writer.write(json.toString());
				writer.flush();
			}
		}catch(Exception e){}
		locker.remove(key);
	}

	
	
}
