package dev.peerat.backend.routes.admins.puzzle;

import static dev.peerat.framework.RequestType.PUT;

import java.util.regex.Matcher;

import dev.peerat.backend.model.Puzzle;
import dev.peerat.backend.repository.DatabaseRepository;
import dev.peerat.framework.Context;
import dev.peerat.framework.HttpReader;
import dev.peerat.framework.HttpWriter;
import dev.peerat.framework.Response;
import dev.peerat.framework.Route;
import dev.peerat.framework.utils.json.JsonMap;

public class EditPuzzle implements Response{
	
	private DatabaseRepository repo;
	
	public EditPuzzle(DatabaseRepository repo){
		this.repo = repo;
	}
	
	@Route(path = "^/admin/puzzle/(\\d+)$", type = PUT, needLogin = true)
	public void exec(Matcher matcher, Context context, HttpReader reader, HttpWriter writer) throws Exception{
		JsonMap json = reader.readJson();
		Puzzle puzzle = new Puzzle(-1, json.get("name"), json.<String>get("content").replace("206\\", "\n").replace("202\\", "\r"), json.<String>get("soluce").replace("206\\", "\n").replace("202\\", "\r").getBytes(), null, json.<Long>get("scoreMax").intValue(), null, -1, null);
		if(repo.adminUpdatePuzzle(Integer.parseInt(matcher.group(1)), puzzle, json.<Long>get("chapter").intValue())){
			context.response(200);
		}else{
			context.response(501);
		}
	}

}
